"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.envFile = void 0;
/* c8 ignore start */ // ?
const fs_js_1 = require("../../polyfills/fs.js");
const list_files_js_1 = require("./list-files.js");
const env_js_1 = require("../../services/env.js");
const regex = {
    comment: /^\s*#/,
};
/** Reads an environment file and sets the environment variables. */
const envFile = (...args_1) => __awaiter(void 0, [...args_1], void 0, function* (filePath = '.env') {
    /* c8 ignore stop */
    const mapEnv = new Map();
    const env = yield (0, fs_js_1.readFile)((0, list_files_js_1.sanitizePath)(filePath), 'utf8');
    const lines = env
        .split('\n')
        .map((line) => (0, env_js_1.removeComments)(line.trim()))
        .filter((line) => line.length > 0 && !regex.comment.test(line));
    for (const line of lines) {
        const parsedLine = (0, env_js_1.parseEnvLine)(line);
        if (parsedLine) {
            const { arg, value } = parsedLine;
            mapEnv.set(arg, value ? (0, env_js_1.resolveEnvVariables)(value, process.env) : value);
        }
    }
    for (const [arg, value] of mapEnv) {
        process.env[arg] = value;
    }
});
exports.envFile = envFile;
